(* HINWEIS : Graphikeinstellungen ab Zeile 48 *)

(* ===========================================================================
:UNIT        RLTurtle
:Contents.   Version der Turbo3-Turtle fr alle von Turbo6/Graph untersttzten
             Graphikkarten. Nicht implementiert : Wrap,Unwrap
:Author.     Renatus Ltticken
:Copyright.  1992 by Renatus Ltticken and Kriewelsch Softworks
:Language.   Pascal
:Translator. Borland Turbo Pascal 6.0
:History.    V0.1 [Ltticken] 8-Oct-1992
             V0.2 [Ltticken] 1-Nov-1992  Debug Clearscreen, LineStyles
             V0.3 [Ltticken] 4-nov-1992  Debug setposition,xcor,ycor
             V0.4 [Ltticken]15-nov-1992  Debug HEADING,BACK
             V1.0 [Ltticken] 3-Feb-1993  Polyclr,Lineclr
               ( Nach dem Aufruf von Polyclr mu die Turtle nach sptestens
                 MAXPOINTS turns zum Ausgangspunkt zurckkommen. Das so
                 umfahrene Polygon wird im Inneren gelscht.
                 ACHTUNG: Ein Eckpunkt wird nur gemerkt, wenn eine Drehung
                 durch setheading oder turnright/left erfolgt. Den letzten
                 Eckpunkt kann man auch durch polyEnd merken.
                 Wird nach Maxpoints Ecken nicht wieder der Ausgangspunkt
                 erreicht, schaltet sich polyclr selbst ab und hat keinen
                 Effekt.
                 ACHTUNG : Im Zustand showturtle kann durch die Wiederherstel-
                 lung des Turtlehintergrundes das Lschen des Polygoninneren
                 gestrt werden, fehlerfrei ist polyclear im Zustand hideturtle.)
             V2.0 [Ltticken] 11-Nov-1994  Die internen Koordinaten der Turtle
                  sind jetzt REAL, dadurch klappt xcor, ycor!!
                  gezeichnet wird an den gerundeten Werten dieser Koordinaten.
                  xcorInt,yCorInt liefern die gerundeten INTEGERWERTE.
                  Bei fast allen Parametern ist jetzt REAL erlaubt!
                  neu : linecolor,
                        grafikrahmen
                        textmodus
                        wiedergrafik
                  neu : Bei Textmodus wird der Graphikbildschirm in der Datei
                        c:turtle.PIX gespeichert, so da er bei der Rckkehr
                        in den Grafikmodus wiederhergestellt werden kann.
                        c:turtle.PIX wird durch turtledone gelscht.
             V2.1[Ltticken] Nov 1998 : Die Turtle kann sich den aktuellen
                  Standort + Blickrichtung unter den Namen A..Z merken.
                  Proc setpoint('A');
                  Diese Punkte kann sie dann mit ToPoint('A') von ihrer
                  momentanen Position aus ansteuern, bei pendown mit Ziehen
                  einer Linie. Sie nimmt dabei auch die beim Merken vorhandene
                  Blickrichtung ein!
                  Mchte man die Blickrichtung in Richtung des Punktes 'A'
                  setzen, benutzt man lookToPoint('A'). Wenn die Turtle auf
                  A steht, hat dieser Befehl keine Auswirkung.
                  Mit der Function   AtPoint(var x:Char): Boolean
                  kann man fragen, auf welchem Punkt
                  die turtle sich befindet. Steht sie auf keinem Punkt, so
                  ist der Rckgabewert #27. Mit pointcor('A',VAR x,y,z:real)
                  kann man fragen, welche Koordinaten der Punkt A hat, und
                  welche Blickrichtung dazugehrt.
                  Beim Start sind alle Punkte 'A'..'Z' mit home initialisiert

=========================================================================== *)

UNIT rlTurtle;
{$D+}
INTERFACE
USES GRAPH , Crt ;

CONST graphPath = 'd:\inf\turbo6\BGI';
(* Einstellung des Graphikbildschirmes: *)
      aspcorrection = 0.99 ;         (* Falls Kreise nicht rund :
                                        erhhen von aspcorrection streckt in
                                        y-Richtung *)
      schritt      = 100 ;           (* Anzahl der Schritte, um den Bildschirm
                                        vertikal auszumessen bei
                                        aspcorrection = 1 *)
           PROCEDURE turtleinit ;    (* MU am Programmanfang !!!!         *)
           PROCEDURE turtleDone;     (* Mu am Programmende, ruft WAIT auf
                                        und lscht die durch textmodus ent-
                                        standene Hintergrunddatei *)
           PROCEDURE ClearScreen;
           PROCEDURE grafikrahmen ;
           PROCEDURE wait     ;      (* anhalten, bis Taste gedrckt wird *)
    (* Bewegungen *)
           PROCEDURE Forwd(Dist: REAL);
           PROCEDURE Back (Dist: REAL);
           PROCEDURE TurnLeft    ( Angle: REAL);
           PROCEDURE TurnRight   ( Angle: REAL);
           PROCEDURE SetPosition ( X,Y  : REAL);
           PROCEDURE Home;
           PROCEDURE SetHeading  ( Angle: REAL);
    (* Turtle-Verhalten *)
           PROCEDURE ShowTurtle;
           PROCEDURE HideTurtle;
           PROCEDURE PenDown;
           PROCEDURE PenUp;
           PROCEDURE TurtleDelay ( Delay: integer);
    (* Linienarten*)
           PROCEDURE dottedline ;       (* Linien gepunkelt    *)
           PROCEDURE dashedline ;       (* Linien gestrichelt  *)
           PROCEDURE solidLine  ;       (* Linien durchgezogen *)
           PROCEDURE thickline  ;       (* Linien dick         *)
           PROCEDURE normalLine ;       (* Linien normal       *)
           PROCEDURE LineColor(color : WORD ) ;
           PROCEDURE Normalcolor ;
    (* Lageinformation*)
           function  Heading: REAL;      (* momentane Richtung  *)
           function  Xcor: REAL;         (* momentane x-Koordinate in REAL*)
           function  Ycor: REAL;         (* momentane y-Koordinate in REAL*)
           function  XcorInt : INTEGER ; (*moment.x-Koordinate in INTEGER *)
           function  YCorInt : INTEGER ; (*moment.y-Koordinate in INTEGER *)

           PROCEDURE NoWrap;         (* Nicht implementiert                *)
           PROCEDURE Wrap;           (* Nicht implementiert                *)
    (* Lschen *)
           PROCEDURE LineClr;        (* Linien werden in der
                                        bkcolor geschrieben, soweit pendown*)
           PROCEDURE NoLineClr ;     (* Beenden von LineClr        *)
           PROCEDURE PolyClr   ;     (* merkt sich alle Punkte, an denen
                                        die turtle gedreht wird. Sobald ein
                                        Polygon umfahren ist, also der An-
                                        fangspunkt erreicht ist, wird das
                                        umfahrene Polygon innen gelscht,
                                       und der Zustand Polyclr wird beendet.*)
           PROCEDURE polyEnd ;       (* merkt, falls Polyclr on ist, den
                                        momentanen Punkt als letzten Eckpunkt
                                        bewirkt dasselbe wie das Erreichen
                                        des Ausgangspunktes.*)

           PROCEDURE textmodus ;
           PROCEDURE Wiedergrafik ;
           Procedure setpoint(x:Char);
           Procedure ToPoint (x:Char);
           Procedure LookToPoint (x:Char);
           Function  AtPoint (Var x: Char):Boolean ;
           Procedure PointCor(a:Char; VAR x,y : Real);


(* Einstellung der Turtle : =================================*)
CONST turtlewinkel = 40 ;
      turtleradius = 22  ;
      nose         = turtleradius DIV 5 ;
      maxpoints    = 50  ; (* MAX-Anzahl der Punkte eines mit Polyclr zu
                              lschenden Polygons *)
      yardcorr     = 3 ; (* wieweit das zu rettend Rechteck den standort umgreift*)
                         (* in yard.def*)

(*====================*)  IMPLEMENTATION   (*==============================*)
(* ========================================================================*)
VAR         AspFactor           : REAL    ;
            xx      : WORD ; (*test*)
            grMode  : INTEGER ;
            normalc : WORD ;

PROCEDURE WAIT;
VAR a: CHAR ;
  BEGIN
    REPEAT UNTIL KEYPRESSED ;
    a := READKEY ;
  END ;

(*=========================================================================*)
(* graphstorer dient dazu, beim Umschalten von Text- auf Graphikmodus den
   Graphikbildschirm wiederherzustellen. *)

CONST storerexist : BOOLEAN = FALSE ;

TYPE    Tgraphstorer = Object
               pb: POINTER ;
               f : FILE ;
               fexist,existstorage : BOOLEAN ;
               size ,
               deltax: WORD ;
               nbOfBlocks : BYTE ;
               PROCEDURE init ;
               procedure done ;
               PROCEDURE saveblocks ;
               PROCEDURE restoreblocks ;
             END ;

VAR storer : Tgraphstorer ;

(*========================================================================*)
TYPE   TYard = Object
          ax,ay,bx,by : INTEGER ;
          PROCEDURE def  ( x00 , y00 , dir, delta     : INTEGER ) ;
          FUNCTION  intersection : BOOLEAN ;
        END ;

  PROCEDURE TYard.def(x00,y00,dir,delta: INTEGER ) ;
    BEGIN  dir := (dir+360) mod 360 ; (* damit nicht neg, <= 360*)
           ax := x00-delta; ay := y00-delta;
           bx := x00+delta; by := y00+delta;
(* Verkleinerung des Rechtecks in Abhngigkeit von der Richtung*)
           IF ( dir>=45) and (dir<135) then (*norden*) by:=y00+yardcorr
           else if (dir>=135) and (dir < 225) then (*westen*) bx:=x00 + yardcorr
           else if (dir >=225) and (dir<315) then (*sden*) ay:=y00- yardcorr
           else (*osten*) ax:=x00- yardcorr;
    END ;

  FUNCTION TYard.intersection : BOOLEAN ;
    VAR intsec : BOOLEAN ;
    BEGIN
      intsec := (ax<=GetMaxX) AND (ay <= GetMaxY)
                  AND ( bx >= 0 ) AND ( by >= 0 ) ;
      IF intsec THEN
        BEGIN
          IF ax < 0 THEN ax := 0 ;
          IF ay < 0 THEN ay := 0 ;
          IF bx > GetMaxX THEN bx := GetMaxX ;
          IF by > GetMaxY THEN by := GetMaxY ;
        END ;
      intersection := intsec ;
    END;
(*========================TYard===========================================*)
(*========================Tturtle=========================================*)

(* Die Angaben in Trec entsprechen dem  Graphikbildschirm : direction=0
   bedeutet Osten, und nicht wie bei der Turtle Norden !. Ebenso ist der
   Punkt 00 hier in der linken oberen Ecke. *)

TYPE Trec = Record
                x,y: Real ;
                direction : REAL ;
             END;


TYPE Tturtle = OBJECT
       CONSTRUCTOR Init ;
       DESTRUCTOR  Done ;
       PROCEDURE   ClrScreen ;
       PROCEDURE   Forward ( Dist : REAL ) ;
       function    Head : REAL ;
       PROCEDURE   Hide ;
       PROCEDURE   Origin ;
       PROCEDURE   NoReturnMode ; (* noch nicht impl. *)
       PROCEDURE   Down ;
       PROCEDURE   Up   ;
       PROCEDURE   SetHead  ( Angle   : REAL ) ;
       PROCEDURE   SetPos   ( nX , nY : REAL ) ;
       PROCEDURE   Show ;
       PROCEDURE   Left       ( Angle : REAL ) ;
       PROCEDURE   Right      ( Angle : REAL ) ;
       PROCEDURE   Hesitation ( Delay : integer ) ;
       PROCEDURE   ReturnMode ;  (* noch nicht impl. *)
       function    XKor : REAL ;
       function    YKor : REAL ;
       function    XKorINT : INTEGER ;
       function    YKorINT : INTEGER ;
       PROCEDURE dotted ;
       PROCEDURE dashed ;
       PROCEDURE solid  ;
       PROCEDURE thick  ;
       PROCEDURE normal ;
       PROCEDURE setlineColor(c:WORD);
       PROCEDURE setnormalColor ;
       PROCEDURE LineClear ;
       PROCEDURE NoLineClear ;
       PROCEDURE PolyClear   ;
       FUNCTION  PolyModeOn : BOOLEAN ;
       PROCEDURE polyoff ;
       Procedure setpoint(x:Char);
       Procedure ToPoint (x:Char);
       Procedure LookToPoint (x:Char);
       Function  AtPoint (Var x: Char):Boolean ;
       Procedure PointCor(a:Char; VAR x,y : Real);


     PRIVATE
       neu ,akt            : TRec    ;    (* in Graphikpixelkoordinaten !*)
       bk                  : POINTER ;    (* DEBUG: ^ByteArray ;   *)
       bkdelta ,size       : Integer ;
       yard                : TYard   ;
       punkte              : array['A'..'Z'] of TRec ;
    (*Shape : *)
       radius, width ,pause: INTEGER ;
       visible , drawing   : BOOLEAN ;
       LineStyle,thickness : WORD    ;
    (*Feld*)
       Pace                : INTEGER ; (* pace pixel=1 vertikaler Schritt  *)
       x0 , y0             : INTEGER ; (* Turtle-Ursprung an diesen Pixeln *)
    (* Lschen*)
       PolyOn              : BOOLEAN ; (* True, wenn durch polyclear Polygon
                                           punkte gemerkt werden sollen *)
       Polypoints          : ARRAY[0..maxpoints] OF pointType ;
       PointNumber         : WORD    ;

       color               : WORD    ; (* Wird bei init festgelegt, durch
                                          setlinecolor verndert *)
       circular            : BOOLEAN ; (* entspricht dann ReturnMode       *)

       PROCEDURE savebk    ;
       PROCEDURE restorebk ;
       PROCEDURE draw      ; VIRTUAL ;
       PROCEDURE move ( n  :TRec ) ;
       PROCEDURE Setrec ( VAR rec : Trec ; rx, ry: REAL; rdir : REAL ) ;
       PROCEDURE StorePoly ;
    END ;(*Object*)

VAR turtle : Tturtle ;

(*=======================TturtleInit=======================================*)

PROCEDURE grInit;
   var
     grDriver ,
     ErrCode  : Integer;
     XAsp,YAsp: WORD   ;

    BEGIN
     grDriver := Detect;
     InitGraph(grDriver,grMode,graphPath);
     ErrCode := GraphResult;
     if ErrCode <> grOk then
       BEGIN
         WriteLn('Graphics error:',GraphErrorMsg(ErrCode));
         READLN; HALT(1);
       END;
       normalc := getcolor ;
       GetAspectRatio ( Xasp , Yasp ) ;
       aspfactor := (Xasp/Yasp) * aspcorrection ;
    END;(* grInit *)

CONSTRUCTOR Tturtle.Init;
  var x : CHAR ;
   BEGIN
     grInit ;
     x0:=(getMaxX+1)DIV 2 ;
     y0:=(getMaxY+1)DIV 2 ;
     pace:= (getmaxY+1) DIV schritt ;
     Graph.SetFillStyle ( 1, graph.GetColor ) ;
     width  := turtlewinkel ;
     radius := turtleradius ;
     SetRec ( akt , x0 , y0 , 90 ) ;

     linestyle := solidln   ;
     Thickness := NormWidth ;
     color     := Graph.getcolor ;

     pause   := 0     ;
     visible := FALSE ;
     drawing := TRUE  ;
     circular:= FALSE ;
     PolyOn  := FALSE ;

     bkdelta := radius + nose ;
     Yard.def (  x0, Y0,round(akt.direction),bkdelta );
     size := ImageSize ( x0-bkdelta , y0-bkdelta , x0+bkdelta , y0+yardcorr) ;
     GETMEM ( bk , size ) ;
     savebk ;
     for x := 'A' to 'Z' do punkte[x]:= akt ;
  END;(* turtle.init *)

(*=========================================================================*)
  DESTRUCTOR Tturtle.Done;
    BEGIN  FREEMEM ( bk , size ) ;  CLOSEGraph ; END ;
(*=======================================================================*)

 PROCEDURE Tturtle.draw ;

   PROCEDURE sector ( rec : TRec ; delta , rad : INTEGER ) ;
    VAR minus ,plus ,gx,gy,gr: INTEGER ;
      BEGIN
       WITH rec DO
       BEGIN
          gx := round(x);gy := round(y);gr := round(direction);
          plus := ( gr + 360 + delta ) MOD 360 ;
          minus:= ( gr + 360 - delta ) MOD 360 ;
          IF  plus < minus  THEN
            BEGIN
              PIESLICE ( gx , gy , minus , 360 , rad ) ;
              PIESLICE ( gx , gy , 0     , plus, rad ) ;
            END
          ELSE
              PIESLICE ( gx , gy , minus , plus, rad ) ;
       END;(*With*)
      END ;(* sector *)


   CONST half = turtlewinkel DIV 2 ;
   VAR  hilf  : TRec ;
           c  : arcCoordsType ;
           gx,gy, gr : INTEGER ;

   BEGIN (*DRAW*)
     setlineStyle(solidLn , 0 , NormWidth) ;
     WITH akt DO
     BEGIN
     gx := round(x);gy := round(y) ;gr := round(direction);
     IF direction = 0
         THEN arc ( gx, gy, 359 , 360, radius + nose )
         ELSE arc ( gx, gy, gr-1, gr , radius + nose ) ;
     getarccoords ( c ) ;
     Setrec ( hilf, c.Xend , c.Yend , gr + 180 );
     sector ( hilf  , 1    , radius+nose  ) ;
     sector ( hilf  , half , radius       ) ;
     SetRec(hilf,(c.Xend+x) / 2 ,(c.Yend+y) / 2,direction) ;
     sector ( hilf, 2*width , radius div 3 ) ;
     END;(*with*)
     setlineStyle(LineStyle , 0 , thickness ) ;
   END;(* Tturtle.DRAW *)
(*========================================================================*)

 PROCEDURE Tturtle.move ( n : TRec ) ;
   BEGIN
     IF visible THEN restorebk ;
     akt := n ;
     savebk   ;
     IF visible THEN Show ;
     Delay ( pause ) ;
   END;(* Tturtle.move *)
(*========================================================================*)
  PROCEDURE TTurtle.savebk    ;
    BEGIN
      yard.def ( round(akt.x) ,round(akt.y) ,round(akt.direction), bkdelta ) ;
      IF Yard.intersection THEN
      WITH akt DO
      GetImage  ( yard.ax, yard.ay , yard.bx, yard.by , bk^ ) ;
    END;(*TTurtle.savebk*)
(*========================================================================*)
  PROCEDURE Tturtle.restorebk ;
    BEGIN
      WITH akt DO
      IF Yard.intersection THEN
      PutImage ( yard.ax, yard.ay , bk^ , CopyPut ) ;
    END; (*TTurtle.savebk*)
(*========================================================================*)
 PROCEDURE Tturtle.Setrec ( VAR rec : Trec ; rx, ry: REAL; rdir : REAL ) ;
   BEGIN
     WITH rec DO
       BEGIN
         x := rx ; y := ry ;
         direction := rdir ;
       END ;
   END;(* Tturtle.setrec*)
(*========================================================================*)
  PROCEDURE Tturtle.ClrScreen;
  TYPE adresse = RECORD ofs,seg:WORD; END;
  VAR bkchar : POINTER ;
   BEGIN
     ClearDevice ;
     bkchar := PTR( adresse(bk).seg,adresse(bk).ofs + 4 ) ;
     FILLCHAR(bkchar^,size,0);       (* Hintergrund lschen *)
   END; (*Tturtle.ClrScreen*)
(*========================================================================*)
  FUNCTION rad(w:Integer):REAL ;
  BEGIN   rad := ( ( 2*PI ) / 360 ) * w ;   END ;

  function degree ( r : Real): Real ;
    begin degree := (r*360)/(2*Pi) ; end ;

  PROCEDURE Tturtle.Forward ( Dist : REAL )  ;
    VAR   factor,gr : INTEGER ;
          alfa   : REAL    ;
   BEGIN
    WITH akt DO
     BEGIN
     factor := round(Dist * pace) ; gr := round (direction) ;
     alfa   := rad( (180 + gr) MOD 360 ) ;
     SetRec ( neu  , x -  factor * cos ( alfa )  ,
                     y +  aspfactor * factor * sin ( alfa )  ,
                     direction ) ;
     IF drawing THEN
       BEGIN
         restorebk ;
         LINE ( round(akt.x) , round(akt.y) , round(neu.x) , round(neu.y) ) ;
         savebk ;
       END ;
     move ( neu ) ;
     END ; (*with*)
   END ; (* TTurtle.forward *)
(*========================================================================*)
  function  Tturtle.Head : REAL ;
   BEGIN    head := akt.direction-90 ;    END;
(*========================================================================*)
  PROCEDURE Tturtle.Hide ;
   BEGIN
     visible := FALSE ;
     restorebk ;
   END ; (* Tturtle.Hide *)
(*========================================================================*)
  PROCEDURE Tturtle.Origin ;
   BEGIN
    setRec ( neu, x0, y0, akt.direction ) ;
    Move   ( neu ) ;
   END ; (* Tturtle.Origin *)
(*========================================================================*)
  PROCEDURE Tturtle.NoReturnMode;
   BEGIN
   END;
 (*========================================================================*)
  PROCEDURE Tturtle.Down ;
   BEGIN   drawing := TRUE ;  END;
 (*========================================================================*)
  PROCEDURE Tturtle.Up ;
   BEGIN   drawing := FALSE ; END;
(*=========================================================================*)
  PROCEDURE Tturtle.SetHead ( Angle : REAL ) ;
   BEGIN
     IF polyOn THEN StorePoly;
     SetRec ( neu , akt.x , akt.y , round(90 + angle) MOD 360 ) ;
     move ( neu ) ;
   END; (*  Tturtle.SetHead *)
(*=========================================================================*)
  PROCEDURE Tturtle.SetPos ( nX , nY : REAL ) ;
   BEGIN
     nx := x0 + (nx * pace);
     ny := y0 - round (ny * pace * aspfactor ) ;
     SetRec ( neu , nx , ny , akt.direction ) ;
     MOVE ( neu ) ;
   END ; (* Tturtle.SetPos *)
(*========================================================================*)
  PROCEDURE Tturtle.Show ;
   BEGIN
     Visible := TRUE ;
     draw ;
   END ; (* Tturtle.Show *)
(*========================================================================*)
  PROCEDURE Tturtle.Left ( Angle: REAL ) ;
   BEGIN
     IF polyOn THEN StorePoly;
     Setrec ( neu, akt.x, akt.y, round( akt.direction + angle ) Mod 360 ) ;
     Move ( neu ) ;
   END ; (* Tturtle.Left *)
(*========================================================================*)
  PROCEDURE Tturtle.Right ( Angle: REAL ) ;
   BEGIN
     IF polyOn THEN StorePoly;
     SetRec (  neu, akt.x, akt.y, round( akt.direction +360 - angle ) Mod 360 ) ;
     Move ( neu ) ;
   END ; (* Tturtle.Right *)
(*========================================================================*)
 PROCEDURE Tturtle.Hesitation ( Delay: integer ) ;
   BEGIN  pause := abs(Delay);  END;
(*========================================================================*)
  PROCEDURE Tturtle.ReturnMode ;
   BEGIN
   END ;
(*========================================================================*)
  function  Tturtle.XKor : REAL ;
   BEGIN   XKor := ( akt.x - x0) /pace ;  END  ;
(*========================================================================*)
  function  Tturtle.YKor : REAL ;
   BEGIN   yKor := (y0 - akt.y) / ( pace * aspfactor ) ;  END  ;
(*========================================================================*)
  function  Tturtle.XKorINT : INTEGER ;
   BEGIN   XKorINT := round(( akt.x - x0) /pace) ;  END  ;
(*========================================================================*)
  function  Tturtle.YKorINT : INTEGER ;
   BEGIN   yKorINT := round((y0 - akt.y) / ( pace * aspfactor )) ;  END  ;
(*========================================================================*)
  PROCEDURE Tturtle.dotted ;
    BEGIN
      Linestyle := dottedln ;
      setlineStyle(LineStyle , 0 , thickness ) ;
    END; (* Tturtle.dotted  *)
(*========================================================================*)
  PROCEDURE Tturtle.dashed ;
    BEGIN
      Linestyle := dashedln ;
      setlineStyle(LineStyle , 0 , thickness ) ;
    END; (* Tturtle.dashed  *)
(*========================================================================*)
  PROCEDURE Tturtle.solid  ;
    BEGIN
      Linestyle := solidln ;
      setlineStyle(LineStyle , 0 , thickness ) ;
    END; (* Tturtle.solid  *)
(*========================================================================*)
  PROCEDURE Tturtle.thick  ;
    BEGIN
      thickness := ThickWidth ;
      setlineStyle(LineStyle , 0 , thickness ) ;
    END; (* Tturtle.thick  *)
(*========================================================================*)
  PROCEDURE Tturtle.normal ;
    BEGIN
      thickness := NormWidth ;
      setlineStyle(LineStyle , 0 , thickness ) ;
    END; (* Tturtle.normal  *)
(*========================================================================*)
  PROCEDURE Tturtle.setLineColor(c:WORD);
  VAR palette : PaletteType ;
    BEGIN
      GetPalette(palette) ;
      IF (c >=0) AND (c<palette.size) AND (c<>graph.getbkcolor)
        THEN BEGIN
               color := c ; setcolor(c);
             END ;
     END ; (* Tturtle.setLineColor*)
(*========================================================================*)
  PROCEDURE Tturtle.setNormalColor;
    BEGIN   setcolor(normalc); END ; (* Tturtle.setNormalColor*)
(*========================================================================*)
       PROCEDURE Tturtle.LineClear ;
         BEGIN
           graph.setcolor(graph.getbkcolor);
         END;(*Tturtle.LineClear *)
(*========================================================================*)
       PROCEDURE Tturtle.NoLineClear ;
         BEGIN
          setcolor(color);
         END;(*Tturtle.NoLineClear *)
(*========================================================================*)
       FUNCTION  Tturtle.PolyModeOn : BOOLEAN ;
         BEGIN
            PolymodeON := PolyOn ;
         END;(*Tturtle.PolymodeOn *)
(*========================================================================*)
       PROCEDURE Tturtle.PolyClear   ;
           VAR point : POINTtype ;
         BEGIN
           point.x := round(akt.x) ; Point.y := round(akt.y);
           PolyOn := TRUE ;
           pointNumber := 1 ;
           polypoints[pointnumber-1]:=point;
         END;(*Tturtle.Polyclear *)
(*========================================================================*)
       PROCEDURE Tturtle.StorePoly   ;
         VAR point : PointType ;
             fill  : Fillsettingstype ;
         BEGIN
           point.x := round(akt.x) ; Point.y := round(akt.y);
           INC(pointnumber);
           IF pointnumber<=maxpoints+1 THEN
           BEGIN
           polypoints[pointnumber-1]:=point;
           IF  (polypoints[0].x=point.x) AND  (PolyPoints[0].y=point.y) THEN
                   BEGIN
                     GetFillSettings (Fill);
                     SetFillStyle(solidfill,getbkcolor);
                     PolyOn := FALSE ;
                     FillPoly(pointnumber,polypoints);
                     SETFILLSTYLE(Fill.pattern,Fill.Color);
                   END;
          END
            ELSE polyOn := FALSE ;
         END;(*Tturtle.storepoly *)

  PROCEDURE Tturtle.polyoff ;
    VAR inter : Trec ;
    BEGIN
     IF polyON THEN
       BEGIN
        storepoly;
        inter:=akt;
        akt.x := polypoints[0].x ;akt.y := polypoints[0].y ;
        storepoly;
        akt := inter ;
      END;
      polyOn := FALSE ;
    END ; (* turtle.polyoff *)

  Procedure Tturtle.setpoint(x:Char);
    BEGIN
      x := upcase(x);
      If NOT (x in ['A'..'Z']) then exit ;
      punkte[x]:= akt ;
    END ;(*Tturtle.setpoint *)

  Procedure Tturtle.ToPoint (x:Char);
    BEGIN
      neu := punkte[x] ;
     IF drawing THEN  (* aus forward kopiert*)
       BEGIN
         restorebk ;
         LINE ( round(akt.x) , round(akt.y) , round(neu.x) , round(neu.y) ) ;
         savebk ;
       END ;
     move ( neu ) ;
     IF polyOn THEN StorePoly;

    END ;(*Tturtle.topoint *)

  Procedure Tturtle.LookToPoint (x:Char);
  VAR w : real ;
    BEGIN
       x := upcase(x);
       if not (x in ['A'..'Z'] )then exit ;
       w := degree(arcTan((punkte[x].y-akt.y)/(punkte[x].x-akt.x)))-90;
       sethead(w);
    END ;(*Tturtle. *)

  Function  Tturtle.AtPoint (Var x: Char):Boolean ;
  var
      gefunden : Boolean;
    BEGIN
      x := 'A';gefunden := false ;
      while (x <='Z') and not gefunden do
      begin
       gefunden := (abs(punkte[x].x-akt.x)<0.02)
                                AND (abs(punkte[x].y-akt.y)<0.02);
       if not gefunden then x := succ(x);
      end;
     AtPoint := gefunden ;

    END ;(*Tturtle.atpoint *)

  Procedure Tturtle.PointCor(a:Char; VAR x,y : Real);
    BEGIN
      a := upcase (a);
      if not (a in ['A'..'Z'] )then exit ;
      X := ( punkte[a].x - x0) /pace ;
      y := ( y0 - punkte[a].y) / ( pace * aspfactor ) ;
    END ;(*Tturtle.PointCor *)


(*========================================================================*)
(*========================================================================*)
(*============ bersetzung des Interface in Objektaufrufe :============== *)

  PROCEDURE turtleInit ;
    BEGIN turtle.Init ; END ;

  PROCEDURE ClearScreen ;
    BEGIN turtle.ClrScreen END ;

  PROCEDURE grafikrahmen ;
  BEGIN rectangle(0,0,getmaxx,getmaxy); END ;

  PROCEDURE Forwd (Dist : REAL) ;
    BEGIN  turtle.Forward ( Dist ) ; END;

  PROCEDURE back (Dist : REAL) ;
  VAR vi : BOOLEAN ;
    BEGIN  WITH turtle DO
      BEGIN
        vi := visible ;
        Hide ;
        Setrec ( neu, akt.x, akt.y, round( akt.direction + 180 ) Mod 360 ) ;
        Move ( neu ) ;
        forward ( Dist ) ;
        Setrec ( neu, akt.x, akt.y, round( akt.direction + 180 ) Mod 360 ) ;
        Move ( neu ) ;
        visible := vi ;
        IF visible THEN show ;
      END ;
    END;

  function  Heading : REAL ;
    BEGIN  heading := turtle.head ;  END;
  PROCEDURE HideTurtle ;
    BEGIN  turtle.Hide ;   END ;
  PROCEDURE Home ;
    BEGIN  turtle.Origin ; END ;
  PROCEDURE NoWrap ;
    BEGIN  turtle.NoReturnMode ; END;
  PROCEDURE PenDown ;
    BEGIN  turtle.Down  ; END ;
  PROCEDURE PenUp ;
    BEGIN  turtle.Up    ; END ;
  PROCEDURE SetHeading ( Angle : REAL ) ;
    BEGIN  turtle.SetHead ( Angle ) ; END ;
  PROCEDURE SetPosition ( X , Y : REAL ) ;
    BEGIN  turtle.SetPos ( X ,Y ) ; END ;
  PROCEDURE ShowTurtle ;
    BEGIN  turtle.Show ; END ;
  PROCEDURE TurnLeft ( Angle : REAL) ;
    BEGIN  turtle.Left ( Angle ) ; END ;
  PROCEDURE TurnRight ( Angle: REAL ) ;
    BEGIN  turtle.Right ( Angle ) ; END ;
  PROCEDURE TurtleDelay ( Delay : integer ) ;
    BEGIN  turtle.Hesitation ( Delay ) ; END ;
  PROCEDURE Wrap ;
    BEGIN  turtle.ReturnMode ; END ;
  function  Xcor : REAL ;
    BEGIN  Xcor  := turtle.XKor ; END ;
  function  Ycor : REAL ;
    BEGIN  YCor  := turtle.YKor END ;
  function  XcorINT : INTEGER ;
    BEGIN  XcorINT  := turtle.XKorINT ; END ;
  function  YcorINT : INTEGER ;
    BEGIN  YCorINT  := turtle.YKorINT END ;
  PROCEDURE dottedline ;             (* Linien gepunkelt    *)
    BEGIN turtle.dotted  ; END;
  PROCEDURE dashedline ;             (* Linien gestrichelt  *)
    BEGIN turtle.dashed  ; END;
  PROCEDURE solidLine ;              (* Linien durchgezogen *)
    BEGIN turtle.solid  ; END;
  PROCEDURE thickline ;              (* Linien dick         *)
    BEGIN turtle.thick  ; END;
  PROCEDURE normalLine ;             (* Linien normal       *)
    BEGIN turtle.normal  ; END;
  PROCEDURE turtleDone ;
    BEGIN  wait ; IF storerexist THEN storer.done; turtle.Done END ;
  PROCEDURE linecolor (color : WORD ) ;
    BEGIN turtle.setlinecolor(color); END ;
  PROCEDURE normalcolor;
    BEGIN turtle.setnormalcolor; END ;
  PROCEDURE LineClr;
    BEGIN turtle.Lineclear ; END ;
  PROCEDURE NoLineClr ;
    BEGIN turtle.nolineclear ; END ;
  PROCEDURE PolyClr   ;
    BEGIN turtle.polyclear ; END ;
  PROCEDURE polyEND ;
    BEGIN turtle.polyoff   ; END ;

  Procedure setpoint(x:Char);
    BEGIN turtle.setpoint(x)   ; END;

  Procedure ToPoint (x:Char);
    BEGIN turtle.ToPoint(x)   ; END;

  Procedure LookToPoint (x:Char);
    BEGIN turtle.Looktopoint(x)   ; END;

  Function  AtPoint (Var x: Char):Boolean ;
    BEGIN Atpoint:=turtle.Atpoint(x)   ; END;

  Procedure PointCor(a:Char; VAR x,y : Real);
    BEGIN turtle.Pointcor(a,x,y)   ; END;


(*=========================================================================*)
(*=========================================================================*)
(*=========================================================================*)
    PROCEDURE Tgraphstorer.init ;
    VAr x,y : INTEGER ;  ss : Longint ;
      BEGIN
        assign(f,'c:turtle.pix'); fexist := false ;
        existstorage := FALSE ;
        pb := NIL ;
        deltax := getmaxx +1; nbOfBlocks := 1 ;
        size := imagesize ( 0,0,deltax-1,getmaxy);
        WHILE size = 0 DO
           BEGIN deltax := deltax DIV 2 ; NBOfBlocks := NbOfBlocks * 2 ;
           size := imagesize ( 0,0,deltax-1,getmaxy); END ;
        storerexist := TRUE ;
      END ; (* Tgraphstorer.init*)
(*=========================================================================*)
    procedure Tgraphstorer.done ;
      BEGIN
        IF fexist THEN erase(f);
        if pb<> NIL THEN FREEMEM(pb,size) ;
        storerexist := FALSE ;
      END ;(* Tgraphstorer.done*)
(*=========================================================================*)
    PROCEDURE Tgraphstorer.saveblocks ;
    VAR xl,xr : INTEGER ; result : WORD ;
      BEGIN
        fexist := TRUE ; existstorage := TRUE ;
        rewrite(f,1);
        NEW(pb);
        xl := 0 ;
        getmem(pb, size );
        xr := deltax-1 ;
        WHILE xr <= getmaxx DO
          BEGIN
             GetImage(xl,0,xr,getmaxy,pb^);
             blockwrite(f,pb^,size,result);
             INC(xr,deltax) ; INC(xl,deltax);
          END ;
        close(f);
      END ; (* Tgraphstorer.saveblocks*)
(*=========================================================================*)
    PROCEDURE Tgraphstorer.restoreblocks ;
    VAR xl : INTEGER ;
      BEGIN
        IF NOT existstorage THEN exit ;
        existstorage := FALSE ;
        reset(f,1);
        xl := 0 ;
        WHILE xl <=getmaxx - deltax+1 DO
          BEGIN
             blockread(f,pb^,size);
             PutImage(xl,0,pb^,normalput);
             INC(xl,deltax);
          END ;
        close(f);
        FREEMEM(pb,size); pb := NIL ;
      END ; (*Tgraphstorer.restoreblocks*)
(*==========================================================================*)

   PROCEDURE textmodus ;
     BEGIN
       IF NOT storerexist THEN storer.init;
       storer.saveblocks;
       restorecrtmode ;
     END ;

   PROCEDURE wiedergrafik ;
     BEGIN
       setgraphmode(grmode);
       IF not storerexist THEN exit ;
       storer.restoreblocks;
     END ;



END.(*UNIT*)